import openai
from pathlib import Path
import plotly.graph_objs as go
from django.shortcuts import render
from plotly.offline import plot
from plotly.graph_objs import Histogram
from select import select
import pandas as pd
import os
from django.conf import settings
from django.contrib.auth.decorators import login_required, permission_required
from datetime import datetime, timedelta
import plotly.express as px
from scipy.stats import t
import numpy as np

from file_manager .models import DataAnalysisQueue, SampleRecord, \
    SavedVisualization, VisualizationApp, UserSettings

APPFOLDER = "media/primary_storage/systemfiles/chatgpt_chat/data/"
if not os.path.exists(APPFOLDER):
    Path(APPFOLDER).mkdir(parents=True)
# for download link
url_base = "primary_storage/systemfiles/chatgpt_chat/data/"

# app name, must be the same as in the database
APPNAME = "Chatgpt Chat"
api_key_file = APPFOLDER + "api_key.txt"
try:
    with open(api_key_file, 'r') as f:
        # It's assumed our file contains a single line,
        # with our API key
        api_key = f.read().strip()
except FileNotFoundError:
    api_key = None

# for pop up warning message


@ login_required
def view(request):
    openai.api_key = api_key
    user_message = ""
    reply = ""
    messages = [
        {"role": "system", "content": "You are a helpful and kind AI Assistant."},
    ]

    if request.method == 'POST':
        if api_key is not None:
            user_input = request.POST.get("user_message")

            messages.append(
                {"role": "user", "content": user_input})
            chat = openai.ChatCompletion.create(
                model="gpt-3.5-turbo", messages=messages
            )
            reply = "Chatgpt: " + \
                chat.choices[0].message.content

            user_message = "You: " + user_input
        else:
            reply = "please ask admin to add in the api key in the file"

    args = {
        "chatgpt_response": reply,
        "your_question": user_message


    }

    return render(request,
                  'filemanager/chatgpt_chat.html', args)
